libdar::ou_mask Class Reference
API

makes the OR operator between two or more masks More...

`#include <mask.hpp>`

Inherits libdar::et_mask.

## Public Member Functions

| ou_mask (const ou_mask &ref)=default
| ou_mask (ou_mask &&ref) noexcept=default
ou_mask & | operator= (const ou_mask &ref)=default
ou_mask & | operator= (ou_mask &&ref) noexcept=default
bool | is_covered (const std::string &expression) const override
| inherited from the mask class More...
bool | is_covered (const path &chemin) const override
| check whether the given path is covered by the mask More...
std::string | dump (const std::string &prefix) const override
| dump in human readable form the nature of the mask More...
mask * | clone () const override
| inherited from the mask class More...
Public Member Functions inherited from libdar::et_mask
| et_mask ()=default
| the constructor to be used by libdar external programs More...
| et_mask (const et_mask &m)
| copy constructor More...
| et_mask (et_mask &&m) noexcept
| move constructor More...
et_mask & | operator= (const et_mask &m)
| assignment operator
et_mask & | operator= (et_mask &&m) noexcept
| move operator More...
| ~et_mask ()
| destructor More...
void | add_mask (const mask &toadd)
| add a mask to the operator More...
bool | is_covered (const std::string &expression) const override
| inherited from the mask class More...
bool | is_covered (const path &chemin) const override
| check whether the given path is covered by the mask More...
std::string | dump (const std::string &prefix) const override
| dump in human readable form the nature of the mask More...
mask * | clone () const override
| inherited from the mask class More...
U_I | size () const
| the number of mask on which is done the AND operator More...
void | clear ()
| clear the mask More...
Public Member Functions inherited from libdar::mask
| mask (const mask &ref)=default
| mask (mask &&ref) noexcept=default
mask & | operator= (const mask &ref)=default
mask & | operator= (mask &&ref) noexcept=default
virtual bool | is_covered (const std::string &expression) const =0
| check wether the given string is covered by the mask More...
virtual bool | is_covered (const path &chemin) const
| check whether the given path is covered by the mask More...
virtual std::string | dump (const std::string &prefix="") const =0
| dump in human readable form the nature of the mask More...
virtual mask * | clone () const =0

## Private Member Functions

template<class T >
bool | t_is_covered (const T &expression) const

## Additional Inherited Members

Protected Member Functions inherited from libdar::et_mask
std::string | dump_logical (const std::string &prefix, const std::string &boolop) const
Protected Attributes inherited from libdar::et_mask
std::deque< mask * > | lst

## Detailed Description

makes the OR operator between two or more masks

this mask has exactly the same use as the et_mask please see the et_mask documentation. The only difference is that it makes an OR operation rather than an AND with the masks added thanks to the add_mask method

Definition at line 359 of file mask.hpp.

## Member Function Documentation

## clone()

mask * libdar::ou_mask::clone | ( |  | ) | const

inline override virtual

inherited from the mask class

Reimplemented from libdar::et_mask.

Definition at line 374 of file mask.hpp.

## dump()

std::string libdar::ou_mask::dump | ( | const std::string & | prefix | ) | const

inline override virtual

dump in human readable form the nature of the mask

Parameters

  [in] | prefix | used for indentation withing the output string

Reimplemented from libdar::et_mask.

Definition at line 372 of file mask.hpp.

## is_covered() [1/2]

bool libdar::ou_mask::is_covered | ( | const path & | chemin | ) | const

inline override virtual

check whether the given path is covered by the mask

Parameters

  [in] | chemin | is the path to check

Returns
  true if the given path is covered by the mask

Note
  only libdar internally needs to call this method
  this is an optional method to the previous one, it can be overwritten

Reimplemented from libdar::et_mask.

Definition at line 371 of file mask.hpp.

## is_covered() [2/2]

bool libdar::ou_mask::is_covered | ( | const std::string & | expression | ) | const

inline override virtual

inherited from the mask class

Reimplemented from libdar::et_mask.

Definition at line 370 of file mask.hpp.

## t_is_covered()

template<class T >

bool libdar::ou_mask::t_is_covered | ( | const T & | expression | ) | const

inline private

Definition at line 377 of file mask.hpp.

The documentation for this class was generated from the following file:

- mask.hpp